#define LGFX_USE_V1
#include <LovyanGFX.hpp>

#define LCD_BLK 46


class LGFX : public lgfx::LGFX_Device
{
    //lgfx::Panel_ILI9341 _panel_instance;
    lgfx::Panel_ILI9488 _panel_instance;
    lgfx::Bus_Parallel16 _bus_instance; 

  public:
    
    LGFX(void)
    {
      { 
        auto cfg = _bus_instance.config(); 

        // 16位设置
        cfg.port = 0;
        cfg.freq_write = 20000000; 
        cfg.pin_wr = 18; 
        cfg.pin_rd = 48; 
        cfg.pin_rs = 45; 

        cfg.pin_d0 = 47;
        cfg.pin_d1 = 21;
        cfg.pin_d2 = 14;
        cfg.pin_d3 = 13;
        cfg.pin_d4 = 12;
        cfg.pin_d5 = 11;
        cfg.pin_d6 = 10;
        cfg.pin_d7 = 9;
        cfg.pin_d8 = 3;
        cfg.pin_d9 = 8;
        cfg.pin_d10 = 16;
        cfg.pin_d11 = 15;
        cfg.pin_d12 = 7;
        cfg.pin_d13 = 6;
        cfg.pin_d14 = 5;
        cfg.pin_d15 = 4;

        _bus_instance.config(cfg);              
        _panel_instance.setBus(&_bus_instance);
      }

      { 
        auto cfg = _panel_instance.config(); 

        cfg.pin_cs = -1; 
        cfg.pin_rst = -1; 
        cfg.pin_busy = -1; 
       

        cfg.memory_width = 320; 
        cfg.memory_height = 480; 
        cfg.panel_width = 320; 
        cfg.panel_height = 480; 
        cfg.offset_x = 0; 
        cfg.offset_y = 0; 
        cfg.offset_rotation = 0; 
        cfg.dummy_read_pixel = 8; 
        cfg.dummy_read_bits = 1; 
        cfg.readable = true; 
        cfg.invert = false; 
        cfg.rgb_order = false; 
        cfg.dlen_16bit = true; 
        cfg.bus_shared = true; 
        _panel_instance.config(cfg);
      }

      setPanel(&_panel_instance); //
    }
};
LGFX lcd;
void setup() {
  // put your setup code here, to run once:
  
  Serial.begin(115200);
  
  lcd.init();
  //lcd.setSwapBytes(true);
  lcd.fillScreen(TFT_BLACK);
  delay(500);
  
  pinMode(LCD_BLK, OUTPUT);
  digitalWrite(LCD_BLK, HIGH);
  lcd.setTextColor(TFT_RED);
  lcd.setTextSize(2);
  lcd.setTextFont(2);
}

void loop() {
  // put your main code here, to run repeatedly:
  lcd.fillScreen(TFT_BLACK);
  int sensorValue = analogRead(19);
  Serial.print("ADC_value： ");
  Serial.println(sensorValue);
  lcd.setCursor(50, 200);
  lcd.printf("                  ");
  lcd.setCursor(50, 200);
  lcd.printf("ADC_value:%d", sensorValue);
  delay(150);
}
