#define LGFX_USE_V1

#include <SPI.h>
#include <SD.h>
//#include <FS.h>
#include <LovyanGFX.hpp>
#include <Ticker.h>          //Call the ticker. H Library
Ticker ticker1;
#include <U8g2lib.h>
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#include <FT6236.h>



#endif
U8G2_SSD1306_128X32_UNIVISION_F_SW_I2C  u8g2(U8G2_R0, /* clock=*/ 39, /* data=*/ 38, /* reset=*/ U8X8_PIN_NONE);   // Adafruit Feather ESP8266/32u4 Boards + FeatherWing OLED

#define I2C_SCL 39
#define I2C_SDA 38

const int i2c_touch_addr = TOUCH_I2C_ADD;
#define get_pos ft6236_pos

#define SPI_MOSI 2 //1
#define SPI_MISO 41
#define SPI_SCK 42
#define SD_CS 1 //2

#define LCD_CS -1
#define LCD_BLK 46


#define G4 392
#define A4 440
#define B4 494
#define C5 523
#define D5 587
#define E5 659
#define F5 698
#define G5 784
int Tone[] = { B4, B4, B4, B4, B4, B4,
               B4, D5, G4, A4, B4,
               C5, C5, C5, C5, C5, B4, B4, B4,
               D5, D5, C5, A4, G4, G5
             };
class LGFX : public lgfx::LGFX_Device
{
    //lgfx::Panel_ILI9341 _panel_instance;
    lgfx::Panel_ILI9488 _panel_instance;
    lgfx::Bus_Parallel16 _bus_instance; 

  public:
    
    LGFX(void)
    {
      { 
        auto cfg = _bus_instance.config(); 

        
        cfg.port = 0; 
        cfg.freq_write = 20000000; 
        cfg.pin_wr = 18; 
        cfg.pin_rd = 48; 
        cfg.pin_rs = 45; 

        cfg.pin_d0 = 47;
        cfg.pin_d1 = 21;
        cfg.pin_d2 = 14;
        cfg.pin_d3 = 13;
        cfg.pin_d4 = 12;
        cfg.pin_d5 = 11;
        cfg.pin_d6 = 10;
        cfg.pin_d7 = 9;
        cfg.pin_d8 = 3;
        cfg.pin_d9 = 8;
        cfg.pin_d10 = 16;
        cfg.pin_d11 = 15;
        cfg.pin_d12 = 7;
        cfg.pin_d13 = 6;
        cfg.pin_d14 = 5;
        cfg.pin_d15 = 4;

        _bus_instance.config(cfg);              // 在总线上反映设置值。
        _panel_instance.setBus(&_bus_instance);
      }

      { 
        auto cfg = _panel_instance.config(); 

        cfg.pin_cs = -1; 
        cfg.pin_rst = -1; 
        cfg.pin_busy = -1; 
       

        cfg.memory_width = 320; 
        cfg.memory_height = 480; 
        cfg.panel_width = 320;
        cfg.panel_height = 480;
        cfg.offset_x = 0; 
        cfg.offset_y = 0; 
        cfg.offset_rotation = 0; 
        cfg.dummy_read_pixel = 8; 
        cfg.dummy_read_bits = 1; 
        cfg.readable = true; 
        cfg.invert = false; 
        cfg.rgb_order = false; 
        cfg.dlen_16bit = true; 
        cfg.bus_shared = true; 
        _panel_instance.config(cfg);
      }

      setPanel(&_panel_instance); 
    }
};

void callback1()  //Callback function
{
  //IO40
  digitalWrite(40, HIGH);
  delay(500);
  digitalWrite(40, LOW);
  delay(500);
}

LGFX lcd;
int pos[2] = {0, 0};
int err_code = 0;
char LU[10];
char B[10];
int i = 0;
int rect_length = 40;
char CloseData;
int NO_Test_Flag = 0;
int Test_Flag = 0;
int Close_Flag = 0;
int wifi_close_flag = 0;



void setup()
{

  Serial.begin(115200);


  pinMode(LCD_BLK, OUTPUT);
  

  
  //OLED
  u8g2.begin();
  u8g2.enableUTF8Print();        // enable UTF8 support for the Arduino print() function
  u8g2.setFont(u8g2_font_ncenB14_tr);
  u8g2.setFontDirection(0);
  Wire.end();
  
  pinMode(40, OUTPUT);
  digitalWrite(40, LOW);
  ticker1.attach(0, callback1);

  
  lcd.init();
  //lcd.setSwapBytes(true);
  lcd.fillScreen(TFT_BLACK);
  delay(500);
  digitalWrite(LCD_BLK, HIGH);
  lcd.setTextColor(TFT_RED);
  lcd.setTextSize(2);
  lcd.setTextFont(2);
  
  //Buzzer
  pinMode(20, OUTPUT);
  ledcSetup(4, 5000, 8);
  ledcAttachPin(20, 4);

}



void loop()
{
   lcd.fillScreen(TFT_RED);
   delay(1000);
   lcd.fillScreen(TFT_BLACK);
   delay(1000);
   lcd.fillScreen(TFT_GREEN);
   delay(1000);
   lcd.fillScreen(TFT_BLACK);
   delay(1000);
   lcd.fillScreen(TFT_YELLOW);
   delay(1000);
   lcd.fillScreen(TFT_BLACK);
   delay(1000);
}
